import os.path
# this a python module the syntax used is the python syntax

##################################
#
# Debug
#
#################################

#used in production
# 0    - the command line is build
#      - the build log is NOT fill
#      - the job is executed

#to test a xml ( python syntax in code , precond ... )
# 1    - the command line is build 
#      - the build log is NOT fill
#      - the job is NOT excuted

#to know what's wrong in the xml I wrote.
# 2    - the command line is build
#      - the build log is fill
#      - the job is NOT executed

#to test the xml and the job execution and the results retrieving
# 3    - the command line is build
#      - the build log is fill
#      - the job is executed

#DEBUG = 0

#to set a different debug level for a particular service
#PARTICULAR_DEBUG ={ 'serviceName' : 3 }


###################################
#
# Directories
#
##################################

#the same as defined in the apache configuration 
DOCUMENT_ROOT = '/the/same/path/as/apache/config'
    
# where to work:
# this is the absolut prefix for jobs results sub-directories
# the results will be in
# TMP_DIR+ programName + xx
# where xx is a random key

RESULTS_PATH = "/the/absolute/path/to/the/results/directory"
#RESULTS_PATH = os.path.join( DOCUMENT_ROOT, 'mobyle', 'results' )

# where the xml programs description 
PROGRAMS_PATH = os.path.join( DOCUMENT_ROOT , 'mobyle', 'programs' )
# When did it disappears ?
PROGRAMS_CACHE_PATH = "/tmp"

# path to the user sessions folder
USER_SESSIONS_PATH = "/the/absolute/path/to/the/session/directory"
#USER_SESSIONS_PATH = os.path.join( DOCUMENT_ROOT , 'mobyle' , 'sessions' )

# Where to jobs infos are stored
JOBS_INFOS_PATH = "/the/absolute/path/to/the/jobs/directory"

# were are the binary corresponding to the services
# a list of string
# each element must be a valid path
# the element order is kept to build the final PATH ( the binary path is add before the canonical PATH )
BINARY_PATH = ["/usr/local/bin"]

#cache pour les template html 
TEMPLATES_CACHE_PATH = "/tmp"



###################################
#
# Portal
#
###################################


# the root url of mobyle 
ROOT_URL = "http://mydomain.fr:port"

# this is the relative path to access to the jobs results sub-directories
# the complete url of a job will be
# ROOT_URL + TMP_URL + programName + xx
# where xx is a random key
# exemple for toppred:
# here  http://kerka.sis.pasteur.fr/Mobyle/Results/toppred/M85111376732714
# this directory should correspond to the TMP_DIR

RESULTS_URL = "Mobyle/Results" #utilise uniquement dans jobstate

#idem for session access
SESSIONS_URL = "Mobyle/Sessions" 

#idem for xml descriptions programs access
PROGRAMS_URL = "mobyle/programs"


#base_project_files_url = '/MobylePortal'
#ROOT_URL + MOBYLEROOT_HTDOCS_URL
MOBYLEROOT_HTDOCS_URL = 'MobylePortal'

#base_project_cgi_url = '/cgi-bin/MobylePortal'
#ROOT_URL + MOBYLEROOT_CGI_URL
MOBYLEROOT_CGI_URL = 'cgi-bin/MobylePortal'



DATABANKS_CONFIG = [
    {'id'       : 'embl' ,
     'dataType' : 'Sequence' ,
     'bioTypes' : ['Nucleic'] ,   
     'label'    : 'EMBL Nucleotide Sequence Database',
     'command'  : ['golden', '%(db)s:%(id)s']
    },
    {'id'       : 'genbank',
     'dataType' : 'Sequence',
     'bioTypes' : ['Nucleic'],
     'label'    : 'Genbank NIH DNA sequence database',
     'command': ['golden', '%(db)s:%(id)s']
    },
    {'id'       : 'genpept', 
     'dataType' : 'Sequence',
     'bioTypes' : ['Protein'],   
     'label'    : 'Genbank Translated Protein-coding Sequences',
     'command': ['golden', '%(db)s:%(id)s']
    },
    {'id'       : 'imgt',
     'dataType' : 'Sequence',
     'bioTypes' : ['Nucleic'],   
     'label'    : 'IMGT - ImMunoGeneTics sequence database',
     'command': ['golden', '%(db)s:%(id)s']
    },
    {'id'       : 'refseq',
     'dataType' : 'Sequence',
     'bioTypes' : ['Nucleic' , 'Protein'],    
     'label'    : 'NCBI Reference Sequence (RefSeq) Database',
     'command': ['golden', '%(db)s:%(id)s']
    },
    {'id'       : 'uniprot', 
     'dataType' : 'Sequence', 
     'bioTypes' : ['Protein'], 
     'label'    : 'UniprotKB - Universal Protein Knowlege Base',
     'command': ['golden', '%(db)s:%(id)s']
    },
    {'id'       : 'wgs',
     'dataType' : 'Sequence', 
     'bioTypes' : ['Nucleic'],    
     'label'    : 'Genbank - Whole Genome Shotgun',
     'command': ['golden', '%(db)s:%(id)s']
    },
    {'id':'pdb',
     'dataType':'3DStructure', 
     'bioTypes':['Protein'], 
     'label': 'Protein Data Bank', 
     'command': [ "/path/to/PDBGet.py", "%(id)s" ]
    }
    ]

#####################################
#
#    Authentication
#
######################################


# to make email optional for all programs, set this to True
# default value = True
#OPT_EMAIL  = True

# to have a more control on the mandatory email
# it able to have the general option but
# it could be set to another value for particular service
# exemple :
# OPT_EMAIL could be set at False ( the email is mandatory )
# but set a True for some very short services.

#PARTICULAR_OPT_EMAIL = {'serviceName' : True }

#anonymous session there is 3 available values 
# no      : the anonymous sessions are not allowed
# yes     : the anonymous sessions are allowed, without any verification 
# captcha : the anonymous sessions are allowed, but with a captcha challenge ( default )
ANONYMOUS_SESSION = "yes"


#authenticated session ther is 3 available values
# 'no'    : the authenticated session are not allowed.
# 'yes'   : the authenticated session are allowed and activated without any restriction.
# 'email' : the authenticated session are allowed but an email confirmation is needed to activate it (default).

#AUTHENTICATED_SESSION = "email"


#####################################
#
#    misc
#
######################################

# default ='en'
#LANG = 'en'

#the time to consider that a job is long ( in sec default = 60 )
#TIMEOUT = 60


# max size for any file (2 Go )
#FILELIMIT = 2147483648

# max size for a session in bytes ( default = 50Mo = 52428800 )
#SESSIONLIMIT = 52428800 

#max size to preview the results 
#if the results size exceed this limit the results appear as a link ( default value = 1048576 = 1Mib )
#PREVIEW_DATA_LIMIT=1048576


#a list of email adresses who will recieved messages when problems occur
MAINTAINER = [ "name@mydommain.fr" ]

#the email adress where the users could have help on this Mobyle portal
HELP="name2@mydommain.fr"

# the From: which send email to the user ( notification of long job, results , session confirmation ) 
# by default SENDER = HELP
SENDER="name3@mydomain.com"

# local mailhost
MAILHOST= "mailhost.mydommain.fr"

#set this True if you don't want results to be sent by email.
#This does not make email optional
#DONT_EMAIL_RESULTS = False

# max size for results by email ( in bytes default 2 Mib )
#MAXMAILSIZE = 2097152

# how long should results be available on the server ( in days default = 10)?
#RESULT_REMAIN = 10


# if you want to resolv the domain name of the user email
# and if it has a mail exchanger field
# (to avoid fake user email address)
# by default DNS_RESOLVER = False
# if DNS_RESOLVER = True dnspython must be installed

#DNS_RESOLVER = False



####################################################
#                                                  #
#    programs needed by the sequences format       #
#          detection and conversion                # 
#                                                  #
####################################################

# the 2 sequences conveter supported by Mobyle are
# squizz and the java version of readseq
# squizz is HIGHLY recommanded

SEQCONVERTER= {
    'SQUIZZ': '/usr/local/bin/squizz',
    }



#####################################
#
# queuing system
#
######################################

# the allowed values are : SGE , Sys
# is plan to be supported PBS .
# mandatory
BATCH = "SGE"

#if you want to use another "queuing system" for a special service
#for all program I use SGE but for toppred which is fast I preferd to 
#launch it in Sys
#PARTICULAR_BATCH = { 'toppred' : 'Sys'}

# the name of the default queue
#DEFAULT_Q = 'local'


# the name of a particular queue for a service
#PARTICULAR_Q = {'golden' : 'short' }


#Q_PROPERTIES={}
   



##########################################################################
#                                                                        #
#  SGE Configuration (only if you set SGE in BATCH or PARTICULAR_BATCH)  #
#                                                                        #
##########################################################################


#SGE_ROOT = "/local/gensoft/adm/sge" 
#SGE_CELL = "gensoft"


########################################
#
#       logging
#
########################################

#the directory were will stored the log files
LOGDIR = '/var/log/Mobyle'

# to monitored the elapsed time per job ( default = False )
#ACCOUNTING = True


#########################################
#
# disabling services
#
#########################################


#DISABLE_ALL = False

#DISABLED_SERVICES = [ ] 


#########################################
#
# restriction services access
#
#########################################


#AUTHORIZED_SERVICES = {}


# serviceName : [ ip , ip mask ]

# the ip address which can use the service
# ip syntax
#
# 'toppred' : [ '125.234.60.18' , # only the machine with this ip could acces to toppred
#               '125.234.60.*'  , # all the machines in subnet could acces to toppred
#               '125.234.*.15   , # all the machine 
#             ] 
#
# if there is no entry for a service it's mean that
# every body can acces to this service

################################
#                              #
#      Services Management     #
#                              #
################################
#by default ORDER=['include' , 'exclude' ]
#ORDER=[ 'include' , 'exclude' ]

#list of programs unix mask to install or not ( without the extension .xml)

#by default INCLUDE= [ '*' ]
#INCLUDE=[ 'bl*' , '*pars*' ] # means all programs begining by "bl" : blas2t , bl2seq ... will be installed
                              #                    containing "pars" : dnapars, protpars , pars ...  will be installed          

#by default EXCLUDE=[]




#########################################
#
# Grid aspects
#
#########################################

EXPORTED_SERVICES = [ 'golden', 'abiview' ]

PORTALS={'portal1': {
            'url': 'http://otherdomain.fr:port/cgi-bin/MobylePortal',
            'help' : 'help@otherdomain.fr',
            'repository': 'http://otherdomain.fr:port/MobyleData/programs',
            'programs': ['clustalw-multialign'],
            'jobsBase': 'http://otherdomain.fr:port/MobyleData/jobs'            
            }
        }

###############################################################################
#
# Local program installation section
#
# This configuration file is used to published the xml programs description on   # 
# the Mobyle web part from the Mobyle/Local/Programs and Mobyle/Programs.        # 
# all the xml from Local/Programs are published ( PROGRAMS_PATH in Config.py )   #
# the xml from Programs are filtered following these rules                       #
#                                                                                #
# ( if this file doesn't exist all the programs from Programs were be published) #
###############################################################################
LOCAL_INSTALL_ORDER=['include' , 'exclude' ]

LOCAL_INSTALL_INCLUDE = [ 'golden', 'clustalw*', 'dnadist', 'fitch', 'kitsch', 'neighbor', 'protdist', 'clique', 'dnapars', 'mix', 'pars', 'protpars', 'consense', 'drawgram', 'drawtree', 'unroot', 'blast2', 'muscle' ]

LOCAL_INSTALL_EXCLUDE=[]