#! /usr/bin/env python
#############################################################
#                                                           #
#   Author: Herve Menager                                   #
#   Organization:'Biological Software and Databases' Group, #
#                Institut Pasteur, Paris.                   #
#   Distributed under GPLv2 Licence. Please refer to the    #
#   COPYING.LIB document.                                   #
#                                                           #
#############################################################
import mb_cgi
from Mobyle.DataInputsIndex import *
from  Mobyle.Classes.DataType import DataTypeFactory

class DatatypesList(mb_cgi.JSONCGI):
    """
    Datatype information
    
    @author: Herve Menager
    @organization: Institut Pasteur
    @contact:mobyle@pasteur.fr
    """
    
    def process( self ):
        dataInputs = DataInputsIndex()
        datatypes = {}
        df = DataTypeFactory()
        for parameter in dataInputs.getList():
            if not(datatypes.has_key(parameter.get('dataTypeClass'))):
                datatypes[parameter.get('dataTypeClass')]={}
                if parameter.get('dataTypeSuperClass'):
                    dt = df.newDataType(parameter.get('dataTypeSuperClass'),parameter.get('dataTypeClass'))
                else:
                    dt = df.newDataType(parameter.get('dataTypeClass'))
                datatypes[parameter.get('dataTypeClass')]['ancestorTypes']=dt.ancestors
        self.jsonMap = datatypes

if __name__ == "__main__":
    il = DatatypesList()
    il.process()
    il.render()