#! /usr/bin/env python
#############################################################
#                                                           #
#   Author: Herve Menager                                   #
#   Organization:'Biological Software and Databases' Group, #
#                Institut Pasteur, Paris.                   #
#   Distributed under GPLv2 Licence. Please refer to the    #
#   COPYING.LIB document.                                   #
#                                                           #
#############################################################
import mb_cgi

class JobRemove(mb_cgi.JSONCGI):
    """
    This class defines the I{JobRemove} cgi
    
    @author: Herve Menager
    @organization: Institut Pasteur
    @contact:mobyle@pasteur.fr
    """
    
    def process( self ):
        if self.session:
          self.session.removeJob(self.request.getfirst('id'))
        from string import Template
        s = "Job $job_id has been succesfully removed"
        t = Template(s)
        body = t.substitute(
                     job_id = self.request.getfirst('id',None),
                     )
        self.jsonMap['msg_body'] = body

if __name__ == "__main__":
    jr = mb_cgi.SessionCGI(JobRemove())
    jr.process()
    jr.render()